/*============================================================================*/
/* 変更履歴                                                                   */
/*----------------------------------------------------------------------------*/
/* 1.0 : 新しいAPIに対応 2003/06/20                                           */
/* 1.1 : デリミタの汎用化対応 2003/09/26                                      */
/* 1.2 : -eパラメータ追加 2004/03/02                                          */
/*============================================================================*/
   
#include <musashi.h>
#include <stdlib.h>
#include <limits.h>

#include <xtnumberHelp.h>
struct mssComHelp comHelp={
  "xtnumber",     /* コマンド名       */
  "1.2",          /* バージョン       */
  HELPT,          /* コマンドタイトル */
  HELPS,          /* 要約             */
  HELPE,          /* 利用例           */
  HELPR,          /* 参照コマンド     */
  HELPA,          /* 作者情報         */                                      
  HELPB,          /* バグレポート情報 */
  HELPH           /* ホームページ     */
};  

extern struct mssGlobalVariables mssGV;

int sameSRTfld(struct mssFldRecDbl *frd, MssOptFLD *optSRT, int kb){
  int i;
  int fldNo;

  for(i=0; i<optSRT->flds->cnt; i++){
    fldNo=MssFlds2num(optSRT->flds,i);
    if(kb==1) return(0);
    if(strcmp(*(frd->pnt[frd->new]+fldNo),*(frd->pnt[frd->old]+fldNo)) != 0){
      return(0);
    }
  }
  return(1);
}

int main(int argc, char *argv[]){
/*============================================================================*/
/* オプション宣言＆定義                                                       */
/*============================================================================*/
/*----------------------------------------------------------------------------*/
/* キー項目                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptKEY optKEY={
    OKEY,   /* オプションタイプ                                             */
    "k",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    MssFieldMaxCnt, /* 指定可能な最大項目数                                 */
    "i",    /* 対象とする入力データのキーワード(GUIで利用)                  */
    2,      /* デフォルト(このオプションが指定されなかったときの動作を指定) */
            /* 1:全ての行を異るキー値として扱う                             */
            /* 2:全ての行を同じキー値として扱う)                            */
    KEYT,   /* このオプションのタイトル(Helpで表示)                         */
    KEYC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* ソート項目                                                                 */
/*----------------------------------------------------------------------------*/
  MssOptFLD optSRT={
    OFLD,   /* オプションタイプ                                             */
    "s",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    MssFieldMaxCnt, /* 指定可能な最大項目数                                 */
    "i",    /* 対象とする入力データのキーワード(GUIで利用)                  */
    0,      /* 正規表現を許可するかどうか(0:不可,1:可)                      */
    0,      /* 新項目名を指定できるかどうか(0:不可,1:可)                    */
    "n,r",  /* 項目オプション(%以下)で指定可能な文字                        */
            /* ex) 指定不可の場合はNULL, "nr": "-f 項目名%rn"の指定可能     */
    SRTT,   /* このオプションのタイトル(Helpで表示)                         */
    SRTC,   /* このオプションのコメント(Helpで表示)                         */
    SRTF    /* フラグについての説明(Helpで表示)複数の場合はカンマで区切る   */
  };

/*----------------------------------------------------------------------------*/
/* 新項目名                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptSLS optFNM={
    OSLS,   /* オプションタイプ                                             */
    "a",    /* キーワード(複数文字は不可)                                   */
    2,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    NULL,   /* デフォルト(文字列)                                           */
    1,      /* カンマで区切られる要素数の最大値                             */
    1,      /* 各要素の文字列長の最小値                                     */
    MssFieldNameMaxLen,/* 各要素の文字列長の最大値                          */
    0,      /* 1:要素にコロンを指定できる,0:不可  ex) aaaa:xxxxx            */
    FNMT,   /* このオプションのタイトル(Helpで表示)                         */
    FNMC    /* このオプションのコメント(Helpで表示)                         */
  }; 

/*----------------------------------------------------------------------------*/
/* 開始番号                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptINT optBGN={
    OINT,   /* オプションタイプ                                             */
    "S",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    1,      /* デフォルト(数値として指定)                                   */
    INT_MIN,/* 最小値                                                       */
    INT_MAX,/* 最大値                                                       */
    BGNT,   /* このオプションのタイトル(Helpで表示)                         */
    BGNC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* インターバル                                                               */
/*----------------------------------------------------------------------------*/
  MssOptINT optINT={
    OINT,   /* オプションタイプ                                             */
    "I",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    1,      /* デフォルト(数値として指定)                                   */
    INT_MIN,/* 最小値                                                       */
    INT_MAX,/* 最大値                                                       */
    INTT,   /* このオプションのタイトル(Helpで表示)                         */
    INTC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 同じソート項目の値に対する処理                                             */
/*----------------------------------------------------------------------------*/
  MssOptSEL optSAM={
    OSEL,   /* オプションタイプ                                             */
    "e",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    "seq",  /* デフォルト(文字列にて)                                       */
    "seq,same,skip",
            /* 指定可能な値リスト                                           */
    SAMT,   /* このオプションのタイトル(Helpで表示)                         */
    SAMC,   /* このオプションのコメント(Helpで表示)                         */
    SAMS    /* フラグについての説明(Helpで表示)複数の場合はカンマで区切る   */
  };

/*----------------------------------------------------------------------------*/
/* キー毎連番                                                                 */
/*----------------------------------------------------------------------------*/
  MssOptFLG optBKY={
    OFLG,   /* オプションタイプ                                             */
    "B",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    BKYT,   /* このオプションのタイトル(Helpで表示)                         */
    BKYC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* シーケンシャル処理                                                         */
/*----------------------------------------------------------------------------*/
  MssOptFLG optSEQ={
    OFLG,   /* オプションタイプ                                             */
    "q",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    SEQT,   /* このオプションのタイトル(Helpで表示)                         */
    SEQC    /* このオプションのコメント(Helpで表示)                         */
  };
    
/*----------------------------------------------------------------------------*/
/* 入力ファイル                                                               */
/*----------------------------------------------------------------------------*/
  MssOptINF optINF={                                                             
    OINF,   /* オプションタイプ                                             */
    "i",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須                                         */
    1,      /* 指定可能の最大ファイル数                                     */
    0,      /*1:file not foundのエラーで終了しない 0:する                   */
    INFT,   /* このオプションのタイトル(Helpで表示)                         */
    INFC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 出力ファイル                                                               */
/*----------------------------------------------------------------------------*/
  MssOptOTF optOTF={
    OOTF,   /* オプションタイプ                                             */
    "o",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須                                         */
    OTFT,   /* このオプションのタイトル(Helpで表示)                         */
    OTFC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 圧縮出力                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptFLG optZIP={
    OFLG,   /* オプションタイプ                                             */
    "z",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    ZIPT,   /* このオプションのタイトル(Helpで表示)                         */
    ZIPC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* plain text                                                                 */
/*----------------------------------------------------------------------------*/
  MssOptFLG optTXT={
    OFLG,   /* オプションタイプ                                             */
    "t",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    TXTT,   /* このオプションのタイトル(Helpで表示)                         */
    TXTC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* ワークファイル用ディレクトリ名                                             */
/*----------------------------------------------------------------------------*/
  MssOptSTR optTMP={
    OSTR,   /* オプションタイプ                                             */
    "T",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    MssTempDir, /* デフォルト                                               */
    1,      /* 文字列の最小長                                               */
    MssFileNameMaxLen,  /* 文字列の最大長                                   */
    TMPT,   /* このオプションのタイトル(Helpで表示)                         */
    TMPC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* オプションをまとめる                                                       */
/*----------------------------------------------------------------------------*/
  void *opt[]={&optKEY,&optSRT,&optBGN,&optINT,&optSAM,&optBKY,&optFNM,&optSEQ,
               &optINF,&optOTF,&optZIP,&optTXT,&optTMP,NULL};

/*============================================================================*/
/* 変数宣言＆定義                                                             */
/*============================================================================*/
  struct mssHeader    *hdi; /*入力ファイル用<head>タグ格納構造体*/
  struct mssHeader    *hdo; /*出力ファイル用<head>タグ格納構造体*/
  struct mssFPR       *fpr; /*入力ファイル構造体                */
  struct mssFPW       *fpw; /*出力ファイル構造体                */
  struct mssFldRecDbl *frd; /*項目-二行バッファ構造体           */
  struct mssFields    *sf;  /*ソート項目構造体                  */
  int sorted;               /*ソート済チェック用                */     

  int seqCnt;             /*キー内もしくはキー毎の件数カウンタ*/
  int samCnt;             /*キー内もしくはキー毎の件数カウンタ(同順位考慮)*/
  int same;
  int skip;
  int kb;

/*----------------------------------------------------------------------------*/
/* 前処理                                                                     */
/*----------------------------------------------------------------------------*/
  mssInit(argc,argv,&comHelp);       /* シグナル処理などの初期化              */
  mssHelpDoc(opt,&comHelp,argc,argv);/* ヘルプ                                */
  mssSetOption(opt,argc,argv);       /* コマンドオプションの設定              */
  fpr=mssOpenFPR(optINF.str,4);      /* 入力ファイルオープン                  */
  hdi=mssReadHeader(fpr);            /* ヘッダの読み込み                      */
  mssSetOptKey(&optKEY, hdi);        /* -k 項目をヘッダー項目に関連づける     */
  mssSetOptFld(&optSRT, hdi);        /* -s 項目をヘッダー項目に関連づける     */
    
  /*ソート項目の作成*/
  sf=mssInitFields();
  mssAddFieldsByFields(sf,optKEY.flds); /* -k 項目をソート項目としてセット    */
  mssAddFieldsByFields(sf,optSRT.flds); /* -s 項目をソート項目としてセット    */
  mssSetFieldsSortPriority(sf);         /* ソート優先順位番号を登録順にふる   */
  sorted=mssChkSorted(sf,hdi);          /* ソート済かチェック                 */
  
/*mssShowFields(sf);*/
/*mssShowOption(opt);*/
/*mssShowHeader(hdi);*/

  /*----------------------------*/
  /*パラメータ間の依存性チェック*/
  /*----------------------------*/
  /*-e same|skip と -Bは同時指定不可*/
  if( 0!=strcmp(optSAM.str,"seq") && optBKY.set ){
    mssShowErrMsg("[-e same|skip] cannot be specified with -B");
    exit(mssErrorNoDefault);
  }

  /*-e same|skip は-sの指定がなければならない*/
  if( 0!=strcmp(optSAM.str,"seq") && !optSRT.set ){
    mssShowErrMsg("[-e same|skip] must be specified with -s");
    exit(mssErrorNoDefault);
  }

  /*-s と -Bは同時指定不可*/
  if( optSRT.set && optBKY.set ){
    mssShowErrMsg("-s cannot be specified with -B");
    exit(mssErrorNoDefault);
  }


/*----------------------------------------------------------------------------*/
/*出力ヘッダーの作成と出力                                                    */
/*----------------------------------------------------------------------------*/
  /*出力ヘッダーの初期化(タイトル等のコピー)*/
  hdo=mssInitCpyHeader(hdi);

  /*入力ヘッダの全項目を追加*/
  mssAddFieldsByFields(hdo->flds,hdi->flds);

  /*新項目名を追加する*/
  mssAddFieldsByStrList(hdo->flds,optFNM.strList,optFNM.cnt);

  /*ソートする必要があるならばsfのソート情報を反映*/
  if(!optSEQ.set && !sorted){
    mssSetFieldsSort(hdo->flds,sf);
  }
  
  /*標準出力オープン+ヘッダーの出力*/
  fpw=mssOpenFPW(optOTF.str,optZIP.set,0);
  mssWriteHeader(hdo, fpw);

/*------------------------------------------------------------------------------
メインルーチン
  Seq集計でなく and sortedでない -> presort + キーブレーク処理
  その他                         ->           キーブレーク処理
------------------------------------------------------------------------------*/
  same=0;
  skip=0;
  if( 0==strcmp(optSAM.str,"same") ){
    same=1;
    skip=0;
  }

  if( 0==strcmp(optSAM.str,"skip") ){
    same=1;
    skip=1;
  }

  /*ソートが必用ならばソートしてソート済みファイルとしてオープン*/
  if( !optSEQ.set && !sorted)
    fpr=mssReopenFPRsort(fpr,4,sf,hdi->flds->cnt,optTMP.str);

  frd=mssInitFRD(hdi->flds->cnt);
  samCnt=optBGN.val-optINT.val;
  seqCnt=optBGN.val-optINT.val;
  if(optBKY.set){
    seqCnt += optINT.val;
  }
  kb=1;
  while( EOF!=mssReadFRD(fpr,frd) ){

    /*キーブレイク時の処理*/
    if(mssKeyBreak(frd, &optKEY)){
      if(frd->eof) break;

      if(optBKY.set){
        seqCnt += optINT.val;
      }else{
        samCnt=optBGN.val-optINT.val;
        seqCnt=optBGN.val-optINT.val;
      }
      kb=1;
    }

    mssGV.inCnt++;

    /*通常行の処理(カウントアップ)*/
    if(!optBKY.set){
      if(same){
        if( sameSRTfld(frd,&optSRT,kb) ){
          seqCnt += optINT.val;
        }else{
          if(skip){
            seqCnt += optINT.val;
            samCnt = seqCnt;
          }else{
            seqCnt += optINT.val;
            samCnt += optINT.val;
          }
        } 
      /* -e seq の場合 */
      }else{
        seqCnt += optINT.val;
      }
    }

    /*書き出し*/
    mssWriteFld(frd->pnt[frd->new],frd->fldCnt,MssFieldDelimStr,fpw);
    if(same){
      mssWriteInt(samCnt,fpw); mssWriteRet(fpw);
    }else{
      mssWriteInt(seqCnt,fpw); mssWriteRet(fpw);
    }

    kb=0;
    mssGV.outCnt++;
  }
  mssFreeFRD(frd);

/*------------------------------------------------------------------------------
フッター出力&終了処理
------------------------------------------------------------------------------*/
/*printf("allocCnt=%d\n",getAllocCnt());*/
  mssWriteFooter(fpw);    /* フッターの出力             */
  mssCloseFPR(fpr);       /* 入力ファイルのクローズ     */
  mssCloseFPW(fpw);       /* 出力ファイルのクローズ     */
  mssFreeFields(sf);      /* ソート項目構造体の領域開放 */
  mssFreeHeader(hdi);     /* 入力ヘッダ領域開放         */
  mssFreeHeader(hdo);     /* 出力ヘッダ領域開放         */
  mssFreeOption(opt);     /* オプション領域開放         */
  mssShowEndMsg();        /* 完了メッセージ             */
  mssEnd(mssExitSuccess); /* 終了                       */
  return(0);              /* to avoid warning message   */
}
