/*============================================================================*/
/* 変更履歴                                                                   */
/*----------------------------------------------------------------------------*/
/* 1.0 : 新しいAPIに対応(2003/06)                                             */
/*============================================================================*/

#include <musashi.h>
#include <stdlib.h>

#include <xtuniqHelp.h>
struct mssComHelp comHelp={
  "xtuniq",       /* コマンド名       */
  "1.0",          /* バージョン       */
  HELPT,          /* コマンドタイトル */
  HELPS,          /* 要約             */
  HELPE,          /* 利用例           */
  HELPR,          /* 参照コマンド     */
  HELPA,          /* 作者情報         */
  HELPB,          /* バグレポート情報 */
  HELPH           /* ホームページ     */
};

extern struct mssGlobalVariables mssGV;

int main(int argc, char *argv[]){
/*----------------------------------------------------------------------------*/
/* キー項目                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptKEY optKEY={
    OKEY,   /* オプションタイプ                                             */
    "k",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    MssFieldMaxCnt, /* 指定可能な最大項目数                                 */
    "i",    /* 対象とする入力データのキーワード(GUIで利用)                  */
    2,      /* デフォルト(このオプションが指定されなかったときの動作を指定) */
            /* 1:全ての行を異るキー値として扱う                             */
            /* 2:全ての行を同じキー値として扱う)                            */
    KEYT,   /* このオプションのタイトル(Helpで表示)                         */
    KEYC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* シーケンシャル処理                                                         */
/*----------------------------------------------------------------------------*/
  MssOptFLG optSEQ={
    OFLG,   /* オプションタイプ                                             */
    "q",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    SEQT,   /* このオプションのタイトル(Helpで表示)                         */
    SEQC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 入力ファイル                                                               */
/*----------------------------------------------------------------------------*/
  MssOptINF optINF={
    OINF,   /* オプションタイプ                                             */
    "i",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須                                         */
    1,      /* 指定可能の最大ファイル数                                     */
    0,      /*1:file not foundのエラーで終了しない 0:する                   */
    INFT,   /* このオプションのタイトル(Helpで表示)                         */
    INFC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 出力ファイル                                                               */
/*----------------------------------------------------------------------------*/
  MssOptOTF optOTF={
    OOTF,   /* オプションタイプ                                             */
    "o",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須                                         */
    OTFT,   /* このオプションのタイトル(Helpで表示)                         */
    OTFC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* 圧縮出力                                                                   */
/*----------------------------------------------------------------------------*/
  MssOptFLG optZIP={
    OFLG,   /* オプションタイプ                                             */
    "z",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    ZIPT,   /* このオプションのタイトル(Helpで表示)                         */
    ZIPC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* plain text                                                                 */
/*----------------------------------------------------------------------------*/
  MssOptFLG optTXT={
    OFLG,   /* オプションタイプ                                             */
    "t",    /* キーワード(複数文字は不可)                                   */
    0,      /* デフォルト(基本的には0) 常にonにしたいときは1にする          */
    TXTT,   /* このオプションのタイトル(Helpで表示)                         */
    TXTC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* ワークファイル用ディレクトリ名                                             */
/*----------------------------------------------------------------------------*/
  MssOptSTR optTMP={
    OSTR,   /* オプションタイプ                                             */
    "T",    /* キーワード(複数文字は不可)                                   */
    0,      /* 0:オプション, 1:必須, 2:XMLtableでのみ必須(txtでは無視)      */
    MssTempDir, /* デフォルト                                               */
    1,      /* 文字列の最小長                                               */
    MssFileNameMaxLen,  /* 文字列の最大長                                   */
    TMPT,   /* このオプションのタイトル(Helpで表示)                         */
    TMPC    /* このオプションのコメント(Helpで表示)                         */
  };

/*----------------------------------------------------------------------------*/
/* オプションをまとめる                                                       */
/*----------------------------------------------------------------------------*/
  void *opt[]={&optKEY,&optSEQ,
               &optINF,&optOTF,&optZIP,&optTXT,&optTMP,NULL};

/*============================================================================*/
/* 変数宣言＆定義                                                             */
/*============================================================================*/
  struct mssHeader    *hdi; /*入力ファイル用<head>タグ格納構造体*/
  struct mssHeader    *hdo; /*出力ファイル用<head>タグ格納構造体*/
  struct mssFPR       *fpr; /*入力ファイル構造体                */
  struct mssFPW       *fpw; /*出力ファイル構造体                */
  struct mssFields    *sf ; /*キー項目構造体                    */
  struct mssFldRecDbl *frd; /*項目-二行バッファ構造体           */
  struct mssUnqDat    *ud;  /*集計計算用の構造体                */

  int sorted;

/*----------------------------------------------------------------------------*/
/* 前処理                                                                     */
/*----------------------------------------------------------------------------*/
  mssInit(argc,argv,&comHelp); /* シグナル処理などの初期化     */           
  mssHelpDoc(opt,&comHelp,argc,argv);/* ヘルプ                       */     
  mssSetOption(opt,argc,argv);    /* コマンドオプションの設定     */        
  fpr=mssOpenFPR(optINF.str,4);/* 入力ファイルオープン         */           
  hdi=mssReadHeader(fpr);      /* ヘッダの読み込み             */
  mssSetOptKey(&optKEY,hdi);   /* 項目パラメータの設定         */

  /*ソート項目の作成*/
  sf=mssInitFields();
  mssAddFieldsByFields(sf,optKEY.flds);                                     
    
  sorted=mssChkSorted(sf,hdi);    /* ソート済かチェック           */        
    
/*----------------------------------------------------------------------------*/
/*出力ヘッダーの作成と出力                                                    */
/*----------------------------------------------------------------------------*/
  /*出力ヘッダーの初期化(タイトル等のコピー)*/                              
  hdo=mssInitCpyHeader(hdi);
    
  if(!optSEQ.set && !sorted){
    mssAddFieldsByFields(hdo->flds,hdi->flds);   /*入力ヘッダの全項目を追加*/
    mssSetFieldsSort(hdo->flds,sf);              /*sfによるソート情報の設定*/
  }else{
    mssAddFieldsByFields(hdo->flds,hdi->flds);   /*入力ヘッダの全項目を追加*/
  }

  /*標準出力オープン+ヘッダーの出力*/
  fpw=mssOpenFPW(optOTF.str,optZIP.set,0);
  mssWriteHeader(hdo, fpw);

/*----------------------------------------------------------------------------*/
/*メインルーチン                                                              */
/*----------------------------------------------------------------------------*/

  ud=mssInitUnqDat(hdi->flds->cnt,&optKEY,optTMP.str,&mssGV.inCnt);

  /*シーケンシャル集計フラグがOffかつソート済みでなければ*/
  if( !optSEQ.set && !sorted){
    ud->procType=1;
    mssPreUnq(ud, fpr);
    while( EOF != mssReadWriteUnq(ud, fpw) ) mssGV.outCnt++;

  /*キーブレーク処理*/
  }else{
    ud->procType=0;
    frd=mssInitFRD(hdi->flds->cnt);
    while( EOF!=mssReadFRD(fpr,frd) ){

      /*キーブレイク時の処理*/
      if(mssKeyBreak(frd, &optKEY)){
        /*一行書き出し*/
        mssWriteFld(frd->pnt[frd->old],frd->fldCnt,"\n",fpw);
        mssGV.outCnt++;
        if(frd->eof) break;
      }
      mssGV.inCnt++;
    }
    mssFreeFRD(frd);
  }
  mssFreeUnqDat(ud);

/*----------------------------------------------------------------------------*/
/*フッター出力&終了処理                                                       */
/*----------------------------------------------------------------------------*/
  mssWriteFooter(fpw);    /*フッターの出力*/
  mssCloseFPR(fpr);       /*入力ファイルのクローズ*/
  mssCloseFPW(fpw);       /*出力ファイルのクローズ*/
  mssFreeFields(sf);      /*ソート項目構造体の領域開放*/
  mssFreeHeader(hdi);     /*入力ヘッダ領域開放*/
  mssFreeHeader(hdo);     /*出力ヘッダ領域開放*/
  mssFreeOption(opt);     /*オプション領域開放*/
  mssShowEndMsg();        /*完了メッセージ*/
  mssEnd(mssExitSuccess); /*終了*/
  return(0); /* to avoid warning message*/
}
